/* Plugin: MedArmory-PRO
 * File: hookedfunctions.cpp
 * Author: Prodigy (jcouzens@uhfco.net)
 * Date: March 30, 2003
 * Info: hooked functions ... 
*/

#include "hookedfunctions.h"
#include "plugin.h"
#include "utilfunctions.h"
#include "clientcommands.h"

extern int global_time;
extern float global_decay;
extern float global_radius;

int DispatchSpawn( edict_t *pent )
{
        if(FStrEq(STRING(pent->v.classname), "worldspawn"))
        {
					PRECACHE_SOUND("hud/tooltip.wav");
					PRECACHE_SOUND("hud/marine_gamestart1.wav");
					PRECACHE_SOUND("weapons/mine_step.wav");
					PRECACHE_MODEL("sprites/laserbeam.spr");
        }
        RETURN_META_VALUE(MRES_HANDLED,0);
}

void StartFrame( void )
{
	int counter;

	float ma_range = 0.0f;
	float ma_dishout = 0.0f;
	float ma_advonly = 0.0f;
	float ma_elec_armory = 0.0f;
	float ma_elec_tf = 0.0f;
	float ma_elec_turret = 0.0f;
	float ma_elec_rt = 0.0f;
	float ma_glow = 0.0f;
	float ma_mines = 0.0f;

	CBaseEntity *pEntity = NULL;
	CBaseEntity *pPlayer = NULL;

	// Armory CVARS
	ma_range = strtofloat(CVAR_GET_POINTER("medarmory_range")->string);
	ma_dishout = strtofloat(CVAR_GET_POINTER("medarmory_dishout")->string);
	ma_advonly = strtofloat(CVAR_GET_POINTER("medarmory_advonly")->string);

	// ELECTRICITY CVARS
	ma_elec_armory = strtofloat(CVAR_GET_POINTER("medarmory_elec_armory")->string);
	ma_elec_tf = strtofloat(CVAR_GET_POINTER("medarmory_elec_tf")->string);
	ma_elec_turret = strtofloat(CVAR_GET_POINTER("medarmory_elec_turret")->string);
	ma_elec_rt = strtofloat(CVAR_GET_POINTER("medarmory_elec_rt")->string);

	// GLOWING WEAPONS
	ma_glow = strtofloat(CVAR_GET_POINTER("medarmory_glow")->string);

	// MINES
	ma_mines = strtofloat(CVAR_GET_POINTER("medarmory_mines")->string);

	if (ma_mines > 0)
	{	
		if (ABSOLUTE_VALUE_EASY(gpGlobals->time - fLastMineTime) >= 4.0f)
		{
			fLastMineTime = gpGlobals->time + 3.0f;
			
			// MINES
			while ((pEntity = UTIL_FindEntityByString(pEntity, "classname", "item_mine")) != NULL)
			{
				// RANDOMLY GLOW BETWEEN 10 AND 35
				pEntity->pev->renderamt = RANDOM_FLOAT ( 10.0, 35.0 );
				pEntity->pev->rendermode = kRenderTransAlpha;
				pEntity->pev->renderfx = kRenderFxNone;
				pEntity->pev->rendercolor = Vector(0, 0, 0);
	
				// IF A MARINE IS NEARBY RENDER 100 (MAX 255)
				for (counter = 1; counter <= gpGlobals->maxClients; ++counter)
				{
					pPlayer = UTIL_PlayerByIndex(counter);
		
					if(pPlayer != NULL)
					{
						if (pEntity->pev->team == pPlayer->pev->team)
						{
							if ((ABSOLUTE_VALUE_EASY(pEntity->pev->origin.x - pPlayer->pev->origin.x) +
								ABSOLUTE_VALUE_EASY(pEntity->pev->origin.y - pPlayer->pev->origin.y) +
								ABSOLUTE_VALUE_EASY(pEntity->pev->origin.z - pPlayer->pev->origin.z)) < ma_range)
							{
								printf("rendering 100\n");
								pEntity->pev->renderamt = 100;
							}
						} // entity is same team as player
						else
						{
							// Fatty
							if (GetPlayerClass(pPlayer->edict()) == 2)
							{
								if ((ABSOLUTE_VALUE_EASY(pEntity->pev->origin.x - pPlayer->pev->origin.x) +
									ABSOLUTE_VALUE_EASY(pEntity->pev->origin.y - pPlayer->pev->origin.y) +
									ABSOLUTE_VALUE_EASY(pEntity->pev->origin.z - pPlayer->pev->origin.z)) < ma_range)
									{
										CLIENT_COMMAND(pPlayer->edict(), "play weapons/mine_step.wav\n" );
									}
							}
						} // entity is on other team
					} // player is valid 
				} // for every player
			} // while found a mine
		} // if its time
	} // mines enabled
		
	if (ABSOLUTE_VALUE_EASY(gpGlobals->time - fLastHealTime) >= 1.0f)
	{
		fLastHealTime = gpGlobals->time + 1.0;

		if (ma_elec_rt > 0)
		{	
			// ELECTRIFY - RESOURCE TOWER
			while ((pEntity = UTIL_FindEntityByString(pEntity, "classname", "resourcetower")) != NULL)
			{
				if (pEntity->edict()->v.iuser2 != 36 &&  pEntity->edict()->v.iuser4 != 536880128 &&
					 pEntity->edict()->v.fuser2 == 1000.0f)
				{
					pEntity->edict()->v.iuser2 = 36;
					pEntity->edict()->v.iuser4 = 536880128;
				}
			}
		} // elec rt 

		if (ma_elec_tf > 0)
		{	
			// ELECTRIFY - TURRET FACTORY
			while ((pEntity = UTIL_FindEntityByString(pEntity, "classname", "team_turretfactory")) != NULL)
			{
				if (pEntity->edict()->v.iuser2 != 36 && pEntity->edict()->v.iuser4 != 536880256 &&
					pEntity->edict()->v.fuser2 == 1000.0f)
				{
					pEntity->edict()->v.iuser2 = 36;
					pEntity->edict()->v.iuser4 = 536880256;
				}
			}
		} // elec tf

		if (ma_elec_turret > 0)
		{
			// ELECTRIFY - TURRET
			while ((pEntity = UTIL_FindEntityByString(pEntity, "classname", "turret")) != NULL)
			{
				if (pEntity->edict()->v.iuser2 != 36 && pEntity->edict()->v.iuser4 != 536880256 &&
					pEntity->edict()->v.fuser2 == 1000.0f)
				{
					pEntity->edict()->v.iuser2 = 36;
					pEntity->edict()->v.iuser4 = 536880256;
				}
			} 
		} // elec turret
	
		if (ma_elec_armory > 0)
		{	
			// ELECTRIFY - ARMORY
			while ((pEntity = UTIL_FindEntityByString(pEntity, "classname", "team_armory")) != NULL) 
			{
				if (pEntity->edict()->v.iuser2 != 36 && pEntity->edict()->v.iuser4 != 536880256 &&
					pEntity->edict()->v.fuser2 == 1000.0f)
				{
					pEntity->edict()->v.iuser2 = 36;
					pEntity->edict()->v.iuser4 = 536880256;
				}
			}
		} // elec armory

		if (ma_glow > 0)
		{	
			// HEAVY MACHINE GUN - GLOW WHITE
			while ((pEntity = UTIL_FindEntityByString(pEntity, "classname", "weapon_heavymachinegun")) != NULL)
			{
				pEntity->pev->renderamt = 20;
				pEntity->pev->rendermode = kRenderNormal;
				pEntity->pev->renderfx = kRenderFxGlowShell;
				pEntity->pev->rendercolor = Vector(255, 255, 255);
				global_decay = 0;
				global_radius = 5;
				global_time = 1000;
				UTIL_DynamicLight_All(Vector(pEntity->pev->origin.x, pEntity->pev->origin.y,pEntity->pev->origin.z + 2),255,255,255);
			}
		
			// SHOTGUN - GLOW BLUE
			while ((pEntity = UTIL_FindEntityByString(pEntity, "classname", "weapon_shotgun")) != NULL)
			{
				pEntity->pev->renderamt = 20;
				pEntity->pev->rendermode = kRenderNormal;
				pEntity->pev->renderfx = kRenderFxGlowShell;
				pEntity->pev->rendercolor = Vector(0, 0, 255);
				global_decay = 0;
				global_radius = 5;
				global_time = 1000;
				UTIL_DynamicLight_All(Vector(pEntity->pev->origin.x, pEntity->pev->origin.y,pEntity->pev->origin.z + 2),255,255,255);
			}

			// GRENADE LAUNCHER - GLOW GREEN
			while ((pEntity = UTIL_FindEntityByString(pEntity, "classname", "weapon_grenadegun")) != NULL)
			{
				pEntity->pev->renderamt = 20;
				pEntity->pev->rendermode = kRenderNormal;
				pEntity->pev->renderfx = kRenderFxGlowShell;
				pEntity->pev->rendercolor = Vector(0, 255, 0);
				global_decay = 0;
				global_radius = 5;
				global_time = 1000;
				UTIL_DynamicLight_All(Vector(pEntity->pev->origin.x, pEntity->pev->origin.y,pEntity->pev->origin.z + 2),255,255,255);
			}

			// WELDER - GLOW RED
			while ((pEntity = UTIL_FindEntityByString(pEntity, "classname", "weapon_welder")) != NULL)
			{
				pEntity->pev->renderamt = 20;
				pEntity->pev->rendermode = kRenderNormal;
				pEntity->pev->renderfx = kRenderFxGlowShell;
				pEntity->pev->rendercolor = Vector(255, 0, 0);
				global_decay = 0;
				global_radius = 5;
				global_time = 1000;
				UTIL_DynamicLight_All(Vector(pEntity->pev->origin.x, pEntity->pev->origin.y,pEntity->pev->origin.z + 2),255,255,255);
			}
		} // glowing

		// START ARMORY HEALING

		// only if we're allowed!
		if (ma_advonly == 0)
		{
			while ( (pEntity = UTIL_FindEntityByString(pEntity, "classname", "team_armory")) != NULL)
			{
				for (counter=1; counter <= gpGlobals->maxClients; ++counter)
				{
					pPlayer = UTIL_PlayerByIndex(counter);

					if (pPlayer != NULL && pPlayer->pev->deadflag == DEAD_NO  && pPlayer->pev->netname)
					{
						if (pEntity->pev->team == pPlayer->pev->team)
						{
							if ((ABSOLUTE_VALUE_EASY(pEntity->pev->origin.x - pPlayer->pev->origin.x) +
								ABSOLUTE_VALUE_EASY(pEntity->pev->origin.y - pPlayer->pev->origin.y) +
								ABSOLUTE_VALUE_EASY(pEntity->pev->origin.z - pPlayer->pev->origin.z)) < ma_range)
								{								
								//give out some health
								if (UTIL_EntityIsBuilt(pEntity) == 1)
								{
									global_decay = 0;
									global_radius = 10;
									global_time = 10;

									UTIL_DynamicLight_All(Vector(pEntity->pev->origin.x, pEntity->pev->origin.y,pEntity->pev->origin.z + 60),255,0,0);

									if (pPlayer->pev->health <= 99.0f && pPlayer->pev->health > 0)
									{
										pPlayer->pev->health += ma_dishout*0.5;
										CLIENT_COMMAND(pPlayer->edict(), "play hud/tooltip.wav\n");

										if (pPlayer->pev->health > 100.0f)
										{
											CLIENT_COMMAND(pPlayer->edict(), "play hud/marine_gamestart1.wav\n" );
											pPlayer->pev->health = 100.0f;
											UTIL_ParticleBeam_All(pPlayer,Vector(pPlayer->pev->origin.x,pPlayer->pev->origin.y,
											pPlayer->pev->origin.z),0,0,255,255,3);
										}// player has health > 100

									}// player has < 99 and > 0 health
								}// ent is built
							}// player is in range
						}// player and entity are on same team
					}// player exists
				}// for every player
			}// while we can find a team armory
		}// if we're accepting basic armory
		
		// healing performed by advanced armory
		while ( (pEntity = UTIL_FindEntityByString(pEntity, "classname", "team_advarmory")) != NULL)
		{
			for (int counter = 1; counter <= gpGlobals->maxClients; ++counter)
			{
				pPlayer = UTIL_PlayerByIndex(counter);
				if (pPlayer != NULL)
				{
					if (pEntity->pev->team == pPlayer->pev->team)
					{
						if ((ABSOLUTE_VALUE_EASY(pEntity->pev->origin.x - pPlayer->pev->origin.x) +
							ABSOLUTE_VALUE_EASY(pEntity->pev->origin.y - pPlayer->pev->origin.y) +
							ABSOLUTE_VALUE_EASY(pEntity->pev->origin.z - pPlayer->pev->origin.z)) < ma_range)
						{
							//give out some health
							if (UTIL_EntityIsBuilt(pEntity) == 1)
							{
								global_decay = 0;
								global_radius = 10;
								global_time = 10;

								UTIL_DynamicLight_All(Vector(pEntity->pev->origin.x, pEntity->pev->origin.y,pEntity->pev->origin.z + 60),0,0,255);

								if (pPlayer->pev->health <= 99.0f && pPlayer->pev->health > 0)
								{
									pPlayer->pev->health += ma_dishout;
										CLIENT_COMMAND(pPlayer->edict(), "play hud/tooltip.wav\n");

									if (pPlayer->pev->health > 100.0f)
									{
										CLIENT_COMMAND(pPlayer->edict(), "play hud/marine_gamestart1.wav\n" );
										pPlayer->pev->health = 100.0f;
										UTIL_ParticleBeam_All(pPlayer,Vector(pPlayer->pev->origin.x,pPlayer->pev->origin.y,
										pPlayer->pev->origin.z),0,0,255,255,3);
									}// player has health > 100

								}// player has < 99 and > 0 health
							}// ent is built
						}// player is in range
					}// player and entity are on same team
				}// player exists
			}// for every player
		}// while we can find a team advanced armory
	} // 1 second timer

	RETURN_META(MRES_IGNORED);
}
