/* Plugin: MedArmory-PRO
 * File: plugin.cpp
 * Author: Prodigy (jcouzens@uhfco.net)
 * Date: March 30, 2003
 * Info: heart of the plugin, some helper functions
*/

#include <extdll.h>		//always
#include <string.h>  	//to prevent linux errors while processing meta_api.h
#include <meta_api.h>
#include <sdk_util.h>	//pre-defined function definitions saves us a lot of work
#include <cbase.h>
#include <player.h>
#include "plugin.h"
#include "utilfunctions.h"
#include "servercommands.h"

float fLastHealTime = 0.0f;
float fLastMineTime = 0.0f;

cvar_t medarmory_dishout = {"medarmory_dishout", "4", FCVAR_ARCHIVE, 0};
cvar_t medarmory_range = {"medarmory_range", "200.0", FCVAR_ARCHIVE, 0};
cvar_t medarmory_advonly = {"medarmory_advonly","0", FCVAR_ARCHIVE, 0};
cvar_t medarmory_elec_armory = {"medarmory_elec_armory", "0", FCVAR_ARCHIVE, 0};
cvar_t medarmory_elec_tf = {"medarmory_elec_tf", "1", FCVAR_ARCHIVE, 0};
cvar_t medarmory_elec_turret = {"medarmory_elec_turret", "0", FCVAR_ARCHIVE, 0};
cvar_t medarmory_elec_rt = {"medarmory_elec_rt", "1", FCVAR_ARCHIVE, 0};
cvar_t medarmory_glow = {"medarmory_glow", "1", FCVAR_ARCHIVE, 0};
cvar_t medarmory_mines = {"medarmory_mines", "1", FCVAR_ARCHIVE, 0};

//=================================================================
//the grand old initialization function
//=================================================================
void plugin_init(void)
{
	
//register all serverside commands that appear in plugin.h
#define REGISTERING_SERVER_COMMANDS
#include "servercommands.h"
#undef REGISTERING_SERVER_COMMANDS

	CVAR_REGISTER(&medarmory_dishout);
	CVAR_REGISTER(&medarmory_range);
	CVAR_REGISTER(&medarmory_advonly);
	CVAR_REGISTER(&medarmory_elec_armory);
	CVAR_REGISTER(&medarmory_elec_tf);
	CVAR_REGISTER(&medarmory_elec_turret);
	CVAR_REGISTER(&medarmory_elec_rt);
	CVAR_REGISTER(&medarmory_glow);
	CVAR_REGISTER(&medarmory_mines);
	
	UTIL_LogPrintf( "[" MY_LOGTAG "] ===============LOADING==============\n");
	UTIL_LogPrintf( "[" MY_LOGTAG "] By Prodigy (jcouzens@uhfco.net)\n");
	UTIL_LogPrintf( "[" MY_LOGTAG "] Version: %s\n", MY_VERSION);
	UTIL_LogPrintf( "[" MY_LOGTAG "] ===============LOADING==============\n");
}


//=================================================================
//the grand old quit function
//=================================================================
void plugin_quit(void)
{
	UTIL_LogPrintf( "[" MY_LOGTAG "] ==============UNLOADING=============\n");
	UTIL_LogPrintf( "[" MY_LOGTAG "] By Prodigy (jcouzens@uhfco.net)\n");
	UTIL_LogPrintf( "[" MY_LOGTAG "] Version: %s\n", MY_VERSION);
	UTIL_LogPrintf( "[" MY_LOGTAG "] ==============UNLOADING=============\n");
}


//=================================================================
//helper functions
//=================================================================
float strtofloat( const char *szStringToConvert )
{
	int counter = 0;
	float returnval = 0;
	bool isnegative = false;
	if(szStringToConvert[0] == '-')
	{
		isnegative = true;
		counter++;
	}
	if(szStringToConvert[0] == '+')
	{
		counter++;
	}
	while(szStringToConvert[counter] >= '0' && szStringToConvert[counter] <= '9' || 
	szStringToConvert[counter] == '.')
	{
		if(szStringToConvert[counter] != '.')
		{
			returnval *= 10;
			returnval += szStringToConvert[counter] - '0';
		}
		else
		{
			counter++;
			float multiple = 1.0;
			while(szStringToConvert[counter] >= '0' && szStringToConvert[counter] <= '9')
			{
				multiple /= 10;
				returnval += (szStringToConvert[counter] - '0') * multiple;
				counter++;
			}			
		}
		counter++;
	}
	if(isnegative) returnval *= -1;
	return returnval;
}

int strtoint( const char *szStringToConvert )
{
	int counter = 0;
	int returnval = 0;
	bool isnegative = false;
	if(szStringToConvert[0] == '-')
	{
		isnegative = true;
		counter++;
	}
	if(szStringToConvert[0] == '+')
	{
		counter++;
	}
	while(szStringToConvert[counter] >= '0' && szStringToConvert[counter] <= '9')
	{
		returnval *= 10;
		returnval += szStringToConvert[counter] - '0';
		counter++;
	}
	
	if(isnegative) returnval *= -1;
	
	return returnval;
}

/*
// handle playing sounds
void EMIT_SOUND_DYN(edict_t *entity, int channel, const char *sample, float volume, 
float attenuation, int flags, int pitch)
{              
        if (sample && *sample == '!')
        {
                char name[32];
                //if (SENTENCEG_Lookup(sample, name) >= 0)
                                EMIT_SOUND_DYN2(entity, channel, name, volume, attenuation, flags, pitch);
                //else                                                                                    
                //      ALERT( at_aiconsole, "Unable to find %s in sentences.txt\n", sample );
        }
        else
                EMIT_SOUND_DYN2(entity, channel, sample, volume, attenuation, flags, pitch);
} 
*/
