/* Plugin: MedArmory
 * File: plugin.h
 * Author: Prodigy (jcouzens@uhfco.net)
 * Date: March 30, 2003
 * Info: Header file for plugin.cpp
*/

//This should contain plugin information and definitions for 
//helper functions

#ifndef _PLUGIN_H_
#define _PLUGIN_H_

//=================================================================
//Plugin Information
//=================================================================
#define MY_DATE				"August 29, 2003" //dd/mm/yy
#define MY_NAME				"MedArmory-PRO"
#define MY_AUTHOR		  "Prodigy <jcouzens@uhfco.net>"
#define MY_URL			  "www.modNS.org"
#define MY_LOGTAG		  "MEDARMORY-PRO"
#define MY_VERSION		"1.06"
#define MY_LOADABLE		PT_CHANGELEVEL
#define MY_UNLOADABLE	PT_ANYTIME

#define MY_VERS_DWORD	1,0,6,0
#define MY_COMMENTS		"If you use it, let us know: http://modNS.org"
#define MY_DESC				"Allows Armories to heal players"
#define MY_FILENAME		MY_LOGTAG ".DLL"
#define MY_INTERNAL		MY_LOGTAG
#define MY_COPYRIGHT  "Licensed under the GPL"

#define ABSOLUTE_VALUE_EASY(x) (((x) < 0) ? (-(x)) : (x))
extern float fLastHealTime;
extern float fLastMineTime;

//=================================================================
//the grand old initialization function
//=================================================================
void plugin_init(void);

//=================================================================
//the grand old quit function
//=================================================================
void plugin_quit(void);

//=================================================================
//helper functions
//=================================================================
float strtofloat( const char *szStringToConvert );
int strtoint( const char *szStringToConvert );

//simplify the process of registering a user message without stepping on anyone else's code unless we have to
inline void SAFE_USER_MSG(int &gmsgvar, const char *szMsgName, const int &iSize) {
	if(gmsgvar == 0) 
	{
		//attempt to get the msg from the game that's running
		gmsgvar = GET_USER_MSG_ID( &Plugin_info, szMsgName, NULL);
		
		//and if that fails, register it ourselves
		if(gmsgvar == 0) gmsgvar = REG_USER_MSG(szMsgName, iSize);
	}
}

#endif // _PLUGIN_H_
