//this file contains function definitions for new serverside commands

//DEFINE_SERVER_COMMAND() Macro
//This macro can be defined in two different ways depending on whether the
//REGISTERING_SERVER_COMMANDS macro is defined, if that macro is undefined then
//DEFINE_SERVER_COMMAND() will simply provide a forward declaration of the function
//in the form void function(void), if the REGISTERING_SERVER_COMMANDS macro is defined
//then DEFINE_SERVER_COMMAND() will run REG_SVR_COMMAND("function", function)
//
//Why you ask: This complex macro exists so that I can add a function to this
//one file and have it all setup and ready to go in every place that needs
//to do something to prepare it. In short: to centralize information

//START - DEFINE_SERVER_COMMAND() Macro
#ifdef DEFINE_SERVER_COMMAND
#undef DEFINE_SERVER_COMMAND
#endif
#ifdef REGISTERING_SERVER_COMMANDS
#define DEFINE_SERVER_COMMAND(function) REG_SVR_COMMAND( "" #function "", function)
#else
#define DEFINE_SERVER_COMMAND(function) void function(void)
#endif
//END - DEFINE_SERVER_COMMAND() Macro

//now that we have all the damn setup out of the way, here is where
//all the functions get defined

//Template: DEFINE_SERVER_COMMAND(commandhere);





